from src.interfaces import IStringCalculator

class StringCalculator(IStringCalculator):
    def add(self, numbers: str) -> int:
        if not numbers:
            return 0

        if numbers.startswith("//"):
            if "\n" not in numbers:
                raise ValueError("Ungültiges Format: Nicht vollständig")
            delimiter_end_index = numbers.index("\n")
            delimiter_part = numbers[2:delimiter_end_index]
            if delimiter_part.startswith("[") and delimiter_part.endswith("]"):
                delimiter = delimiter_part[1:-1]
            else:
                delimiter = delimiter_part
            numbers = numbers[delimiter_end_index + 1:]
            numbers = numbers.replace(delimiter, ",")

        numbers = numbers.replace("\n", ",")

        # Split the string by commas, convert each value to an integer, and sum them up
        try:
            numbers_list = list(map(int, numbers.split(",")))
        except ValueError:
            raise ValueError("Ungültiges Zahlenformat: Enthält nicht-numerische Werte")

        negative_numbers = [num for num in numbers_list if num < 0]
        if negative_numbers:
            raise ValueError(f"Negative nicht erlaubt: {negative_numbers}")

        numbers_list = [num for num in numbers_list if num <= 1000]

        return sum(numbers_list)

'''
Änderung damit die Tests mit den negativen Zahlen durchlaufen:
        negative_numbers = [num for num in numbers_list if num < 0]
        if negative_numbers:
            raise ValueError(f"negatives not allowed: {','.join(map(str, negative_numbers))}")
'''